--- asterisk/apps/app_voicemail.c.orig	2006-08-08 10:50:43.000000000 +1200
+++ asterisk/apps/app_voicemail.c	2006-08-08 10:43:35.000000000 +1200
@@ -1784,12 +1784,17 @@
 			/* Eww. We want formats to tell us their own MIME type */
 			char *ctype = "audio/x-";
 			char tmpdir[256], newtmp[256];
+			int tmpfd;
 
 			create_dirpath(tmpdir, sizeof(tmpdir), vmu->context, vmu->mailbox, "tmp");
 			snprintf(newtmp, sizeof(newtmp), "%s/XXXXXX", tmpdir);
-			mkstemp(newtmp);
-			ast_log(LOG_DEBUG, "newtmp: %s\n", newtmp);
-			if (vmu->volgain < -.001 || vmu->volgain > .001) {
+			tmpfd = mkstemp(newtmp);
+			if (tmpfd == -1)
+				ast_log(LOG_WARNING, "Failed to create temporary file for voicemail volgain change (using %s): %s\n", newtmp, strerror(errno));
+			else
+				ast_log(LOG_DEBUG, "newtmp: %s\n", newtmp);
+			if ((vmu->volgain < -.001 || vmu->volgain > .001)
+					&& tmpfd != -1) {
 				snprintf(tmpcmd, sizeof(tmpcmd), "sox -v %.4f %s.%s %s.%s", vmu->volgain, attach, format, newtmp, format);
 				ast_safe_system(tmpcmd);
 				attach = newtmp;
@@ -1808,7 +1813,10 @@
 			snprintf(fname, sizeof(fname), "%s.%s", attach, format);
 			base_encode(fname, p);
 			fprintf(p, "\n\n--%s--\n.\n", bound);
-			unlink(newtmp);
+			if (tmpfd != -1) {
+				unlink(newtmp);
+				close(tmpfd);
+			}
 		}
 		fclose(p);
 		snprintf(tmp2, sizeof(tmp2), "( %s < %s ; rm -f %s ) &", mailcmd, tmp, tmp);
